On Error Resume Next

Dim strTarget, strPingResults

'Set Constants
Const ForReading = 1

'Dim Objects
Dim objFSO

'Dim Strings
Dim i
Dim strComputer

Set objFSO = CreateObject("Scripting.FileSystemObject")
Set InputFile = objFSO.OpenTextFile("MachineList.Txt")

intcol = 0
introw = 1

'Create Excel Document
Set objExcel = CreateObject("Excel.Application")
objExcel.Visible = True
objExcel.Workbooks.Add

objExcel.Cells(IntRow, IntCol+1).Value = "Machine Name"
objExcel.Cells(IntRow, IntCol+2).Value = "Machine Type"
objExcel.Cells(IntRow, IntCol+3).Value = "Serial Number"
objExcel.Cells(IntRow, IntCol+4).Value = "Logged On"
objExcel.Cells(introw, intcol+5).Value = "Monitor 1 Manufacture Name"
objExcel.Cells(introw, intcol+6).Value = "Monitor 1 User Friendly Name"
objExcel.Cells(introw, intcol+7).Value = "Monitor 1 Serial Number"
objExcel.Cells(introw, intcol+8).Value = "Monitor 1 Week of Manufacture"
objExcel.Cells(introw, intcol+9).Value = "Monitor 1 Year of Manufacture"
objExcel.Cells(introw, intcol+10).Value = "Monitor 2 Manufacture Name"
objExcel.Cells(introw, intcol+11).Value = "Monitor 2 User Friendly Name"
objExcel.Cells(introw, intcol+12).Value = "Monitor 2 Serial Number"
objExcel.Cells(introw, intcol+13).Value = "Monitor 2 Week of Manufacture"
objExcel.Cells(introw, intcol+14).Value = "Monitor 2 Year of Manufacture"
objExcel.Cells(introw, intcol+15).Value = "Monitor 3 Manufacture Name"
objExcel.Cells(introw, intcol+16).Value = "Monitor 3 User Friendly Name"
objExcel.Cells(introw, intcol+17).Value = "Monitor 3 Serial Number"
objExcel.Cells(introw, intcol+18).Value = "Monitor 3 Week of Manufacture"
objExcel.Cells(introw, intcol+19).Value = "Monitor 3 Year of Manufacture"

Do While Not (InputFile.atEndOfStream)

   strComputer = InputFile.ReadLine

   intCol = 1
   intRow = Introw + 1
   objExcel.Cells(intRow, IntCol).Value = strComputer

' --------- Check If PC is on -------------
Set WshShell = WScript.CreateObject("WScript.Shell")
Set WshExec = WshShell.Exec("ping -n 1 -w 1000 " & strComputer) 'send 3 echo requests, waiting 2secs each
strPingResults = LCase(WshExec.StdOut.ReadAll)
If InStr(strPingResults, "reply from") Then
    'Successful ping

	Set objWMIService = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

	Call GetMachineModel()		'Get Machine Model
	Call GetSerialNumber() 		'Get Serial Number
	Call GetLoggedonUser()		'Get Logged On User
	Call GetMonitorInfo() 		'Get Monitor Information

Else
	'Unsuccessful ping
	objExcel.Cells(intRow, 2).Value ="Offline"

	strNewContents = strNewContents & strComputer & vbCrLf

End If

loop

	' --------- Tidy Excel Document -------------
objExcel.Range("A1:S1").Select
objExcel.Selection.Interior.ColorIndex = 19
objExcel.Selection.Font.ColorIndex = 11
objExcel.Selection.Font.Bold = True
objExcel.Cells.EntireColumn.AutoFit

Set objFile = objFSO.OpenTextFile("MachineList.txt", 2)
objFile.Write strNewContents

' --------- Get Machine Model -------------

Function GetMachineModel()

	Set colComputer = objWMIService.ExecQuery("SELECT * FROM Win32_ComputerSystem")

	For Each objComputer in colComputer

		objExcel.Cells(intRow, 2).Value =  objComputer.Model

	Next
End Function

' --------- Get Machine Serial Number -------------

Function GetSerialNumber()

	Set colSMBIOS = objWMIService.ExecQuery("SELECT * FROM Win32_BIOS")
	For Each objSMBIOS in colSMBIOS

		objExcel.Cells(intRow, 3).Value = objSMBIOS.SerialNumber
	Next
end function

' --------- Get Logged on User -------------

Function GetLoggedonUser()

	Set colComputer = objWMIService.ExecQuery("SELECT * FROM Win32_ComputerSystem")

	For Each objComputer in colComputer

		 objExcel.Cells(intRow, 4).Value = objComputer.UserName
	Next
End Function

' --------- Get Monitor Info -------------

Function GetMonitorInfo()
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\WMI")
	Set colMonitors = objWMIService.ExecQuery("SELECT * FROM WmiMonitorID")

	For Each objMonitor in colMonitors
	  ManufacturerName = ""
	  UserFriendlyName  = ""
	  SerialNumber = ""
	  WeekOfManufacture = objMonitor.WeekOfManufacture
	  YearOfManufacture = objMonitor.YearOfManufacture
	   'Convert manufacturer name to ASCII
	  For I = 0 To Ubound(objMonitor.ManufacturerName)
		If objMonitor.ManufacturerName(I) <> 0 Then
		  ManufacturerName = ManufacturerName & Chr(objMonitor.ManufacturerName(I))
		End If
	  Next
	   'Convert user friendly name to ASCII
	  For I = 0 To Ubound(objMonitor.UserFriendlyName)
		If objMonitor.UserFriendlyName(I) <> 0 Then
		  UserFriendlyName = UserFriendlyName & Chr(objMonitor.UserFriendlyName(I))
		End If
	  Next
	  'Convert serial number to ASCII
	  For I = 0 To Ubound(objMonitor.SerialNumberID)
		If objMonitor.SerialNumberID(I) <> 0 Then
		  SerialNumber = SerialNumber & Chr(objMonitor.SerialNumberID(I))
		End If
	  Next

	' Manufacturer Name
	objExcel.Cells(introw, intcol+4).Value =  ManufacturerName

	' User Friendly Name
	objExcel.Cells(introw, intcol+5).Value =  UserFriendlyName

	' Serial Number
	objExcel.Cells(introw, intcol+6).Value =  SerialNumber

	' Week of Manufacture
	objExcel.Cells(introw, intcol+7).Value =  WeekOfManufacture

	' Year of Manufacture
	objExcel.Cells(introw, intcol+8).Value =  YearOfManufacture

	intcol = intcol + 5

	Next
End function